class ComplaintBuilder < Builder
  extend RepositoriesProxy

  ##
  # receive a list of ids and return a list of complaints
  #
  def self.build(complaints = [])
    array = []
    complaints = [complaints] if complaints.class == String
    complaints.each do |complaint|
      unless complaint['@rid'].blank?
        #disable rails cache for complaints
        #o = Rails.cache.fetch(cache_key(complaint['@rid'], complaint['last_modified'])) unless complaint['last_modified'].blank?
        o = complaint_repository.find complaint['@rid'] #if o.nil?
        array << o
      end
    end
    array
  end

  def self.build_from_orientdb(args = {})
    complaint = nil

    unless args.nil?
      args['last_modified'] = nil
      # cache object when build
      complaint = Rails.cache.fetch(cache_key(args['@rid'], args['last_modified']), expires_in: 12.hours) do
        Complaint.new(
            id: args['@rid'],
            user: user_repository.get_by_rid(args['out']),
            created_at: DateTime.strptime(args['created_at'], "%Y-%m-%d %H:%M:%S"),
            object: learning_object_repository.find(args['in']),
            message: ComplaintMessage.new(args['message']),
            description: args['description'] || ''
        )
      end
    end

    complaint
  end

end
