class Complaint
  include ActiveModel::Model
  include OrientDbSerializable

  attr_accessor :user, :object, :message, :description
  validates_presence_of :user, :object, :message

  def self.copyrights
    ComplaintMessage.new("Objeto viola direitos autorais")
  end

  def self.ofensive_content
    ComplaintMessage.new "Objeto contém conteúdo ofensivo/abusivo"
  end

  def self.ofensive_user
    ComplaintMessage.new "Usuário ofensivo/agressivo"
  end

  def self.fake_user
    ComplaintMessage.new "Usuário falso"
  end

  def to_orientdb_hash
    super.merge("user" => @user.rid, "object" => @object.id, "message" => @message.to_s)
  end
end
